View Javadoc

    1   /*
    2    * Copyright 2012 The Netty Project
    3    *
    4    * The Netty Project licenses this file to you under the Apache License,
    5    * version 2.0 (the "License"); you may not use this file except in compliance
    6    * with the License. You may obtain a copy of the License at:
    7    *
    8    *   http://www.apache.org/licenses/LICENSE-2.0
    9    *
    10   * Unless required by applicable law or agreed to in writing, software
    11   * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
    12   * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
    13   * License for the specific language governing permissions and limitations
    14   * under the License.
    15   */
    16  package org.jboss.netty.handler.codec.http.multipart;
    17
    18  import java.nio.charset.Charset;
    19
    20  import org.jboss.netty.handler.codec.http.HttpRequest;
    21
    22  /**
    23   * Interface to enable creation of InterfaceHttpData objects
    24   */
    25  public interface HttpDataFactory {
    26      /**
    27      *
    28      * @param request associated request
    29      * @param name
    30      * @return a new Attribute with no value
    31      * @throws NullPointerException
    32      * @throws IllegalArgumentException
    33      */
    34      Attribute createAttribute(HttpRequest request, String name);
    35
    36      /**
    37       *
    38       * @param request associated request
    39       * @param name
    40       * @param value
    41       * @return a new Attribute
    42       * @throws NullPointerException
    43       * @throws IllegalArgumentException
    44       */
    45      Attribute createAttribute(HttpRequest request, String name, String value);
    46
    47      /**
    48       *
    49       * @param request associated request
    50       * @param name
    51       * @param filename
    52       * @param contentType
    53       * @param charset
    54       * @param size the size of the Uploaded file
    55       * @return a new FileUpload
    56       */
    57      FileUpload createFileUpload(HttpRequest request, String name, String filename,
    58                                  String contentType, String contentTransferEncoding, Charset charset,
    59                                  long size);
    60
    61      /**
    62       * Remove the given InterfaceHttpData from clean list (will not delete the file, except if the file
    63       * is still a temporary one as setup at construction)
    64       * @param request associated request
    65       * @param data
    66       */
    67      void removeHttpDataFromClean(HttpRequest request, InterfaceHttpData data);
    68
    69      /**
    70       * Remove all InterfaceHttpData from virtual File storage from clean list for the request
    71       *
    72       * @param request associated request
    73       */
    74      void cleanRequestHttpDatas(HttpRequest request);
    75
    76      /**
    77       * Remove all InterfaceHttpData from virtual File storage from clean list for all requests
    78       */
    79      void cleanAllHttpDatas();
    80  }